package be.iminds.ilabt.jfed.ui.cli2.instruction;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

/**
 * DebugOutput: instructions on if and how much and how debug output is handled
 */
public class DebugOutput {
    public enum Format { /*JSON,*/ TXT, TXT_FULL }
    public enum Level {
        DEBUG(0, ch.qos.logback.classic.Level.DEBUG),
        INFO(1, ch.qos.logback.classic.Level.INFO),
        WARNING(2, ch.qos.logback.classic.Level.WARN),
        ERROR(3, ch.qos.logback.classic.Level.ERROR);

        final int rank;
        final ch.qos.logback.classic.Level logBackLevel;

        Level(int rank, ch.qos.logback.classic.Level logBackLevel) {
            this.rank = rank;
            this.logBackLevel = logBackLevel;
        }

        public int getRank() {
            return rank;
        }
        public ch.qos.logback.classic.Level getLogbackLevel() {
            return logBackLevel;
        }
    }

    @Nonnull private final Level level;
    @Nonnull private final Format format;
    @Nonnull private final OutputTarget target;
    @Nullable private final String filename;

    public DebugOutput(@Nullable Level level,
                       @Nullable Format format,
                       @Nullable OutputTarget target,
                       @Nullable String filename) {
        this.level = level == null ? Level.ERROR : level;
        this.format = format == null ? Format.TXT : format;
        this.target = target == null ? OutputTarget.STDOUT : target;
        this.filename = filename;
    }

    public DebugOutput() {
        this(null, null, null, null);
    }

    @Nonnull public Level getLevel() {
        return level;
    }

    @Nonnull public Format getFormat() {
        return format;
    }

    @Nonnull public OutputTarget getTarget() {
        return target;
    }

    @Nullable public String getFilename() {
        return filename;
    }
}
